/************************************************************************************************/
/*                                                                                              */
/*  Copyright 2011  Broadcom Corporation                                                        */
/*                                                                                              */
/*                                                                                              */
/*     Unless you and Broadcom execute a separate written software license agreement governing  */
/*     use of this software, this software is licensed to you under the terms of the GNU        */
/*     General Public License version 2 (the GPL), available at                                 */
/*                                                                                              */
/*          http://www.broadcom.com/licenses/GPLv2.php                                          */
/*                                                                                              */
/*     with the following added to such license:                                                */
/*                                                                                              */
/*     As a special exception, the copyright holders of this software give you permission to    */
/*     link this software with independent modules, and to copy and distribute the resulting    */
/*     executable under terms of your choice, provided that you also meet, for each linked      */
/*     independent module, the terms and conditions of the license of that module.              */
/*     An independent module is a module which is not derived from this software.  The special  */
/*     exception does not apply to any modifications of the software.                           */
/*                                                                                              */
/*     Notwithstanding the above, under no circumstances may you combine this software in any   */
/*     way with any other Broadcom software provided under a license other than the GPL,        */
/*     without Broadcom's express prior written consent.                                        */
/*                                                                                              */
/************************************************************************************************/

#ifndef __CHIP_PINMUX_H__
#define __CHIP_PINMUX_H__

/**DONT MANUALLY EDIT - This file is autogenerated using Hawaii pinmux xls**/
/* See http://confluence.broadcom.com/display/MPSANDRDBLR/Hawaii+pin+description+table+generator */

enum PIN_NAME {
	PN_ADCSYN,
	PN_BATRM,
	PN_BSC1CLK,
	PN_BSC1DAT,
	PN_CAMCS0,
	PN_CAMCS1,
	PN_CLK32K,
	PN_CLK_CX8,
	PN_DCLK1,
	PN_DCLK4,
	PN_DCLKREQ1,
	PN_DCLKREQ4,
	PN_DMIC0CLK,
	PN_DMIC0DQ,
	PN_DSI0TE,
	PN_GPIO00,
	PN_GPIO01,
	PN_GPIO02,
	PN_GPIO03,
	PN_GPIO04,
	PN_GPIO05,
	PN_GPIO06,
	PN_GPIO07,
	PN_GPIO08,
	PN_GPIO09,
	PN_GPIO10,
	PN_GPIO11,
	PN_GPIO12,
	PN_GPIO13,
	PN_GPIO14,
	PN_GPIO15,
	PN_GPIO16,
	PN_GPIO17,
	PN_GPIO18,
	PN_GPIO19,
	PN_GPIO20,
	PN_GPIO21,
	PN_GPIO22,
	PN_GPIO23,
	PN_GPIO24,
	PN_GPIO25,
	PN_GPIO26,
	PN_GPIO27,
	PN_GPIO28,
	PN_GPIO32,
	PN_GPIO33,
	PN_GPIO34,
	PN_GPS_CALREQ,
	PN_GPS_HOSTREQ,
	PN_GPS_PABLANK,
	PN_GPS_TMARK,
	PN_ICUSBDM,
	PN_ICUSBDP,
	PN_LCDCS0,
	PN_LCDRES,
	PN_LCDSCL,
	PN_LCDSDA,
	PN_LCDTE,
	PN_MDMGPIO00,
	PN_MDMGPIO01,
	PN_MDMGPIO02,
	PN_MDMGPIO03,
	PN_MDMGPIO04,
	PN_MDMGPIO05,
	PN_MDMGPIO06,
	PN_MDMGPIO07,
	PN_MDMGPIO08,
	PN_MMC0CK,
	PN_MMC0CMD,
	PN_MMC0DAT0,
	PN_MMC0DAT1,
	PN_MMC0DAT2,
	PN_MMC0DAT3,
	PN_MMC0DAT4,
	PN_MMC0DAT5,
	PN_MMC0DAT6,
	PN_MMC0DAT7,
	PN_MMC0RST,
	PN_MMC1CK,
	PN_MMC1CMD,
	PN_MMC1DAT0,
	PN_MMC1DAT1,
	PN_MMC1DAT2,
	PN_MMC1DAT3,
	PN_MMC1DAT4,
	PN_MMC1DAT5,
	PN_MMC1DAT6,
	PN_MMC1DAT7,
	PN_MMC1RST,
	PN_PC1,
	PN_PC2,
	PN_PMBSCCLK,
	PN_PMBSCDAT,
	PN_PMUINT,
	PN_RESETN,
	PN_RFST2G_MTSLOTEN3G,
	PN_RTXDATA2G_TXDATA3G1,
	PN_RTXEN2G_TXDATA3G2,
	PN_RXDATA3G0,
	PN_RXDATA3G1,
	PN_RXDATA3G2,
	PN_SDCK,
	PN_SDCMD,
	PN_SDDAT0,
	PN_SDDAT1,
	PN_SDDAT2,
	PN_SDDAT3,
	PN_SIMCLK,
	PN_SIMDAT,
	PN_SIMDET,
	PN_SIMRST,
	PN_GPIO93,
	PN_GPIO94,
	PN_SPI0CLK,
	PN_SPI0FSS,
	PN_SPI0RXD,
	PN_SPI0TXD,
	PN_SRI_C,
	PN_SRI_D,
	PN_SRI_E,
	PN_SSPCK,
	PN_SSPDI,
	PN_SSPDO,
	PN_SSPSYN,
	PN_STAT1,
	PN_STAT2,
	PN_SWCLKTCK,
	PN_SWDIOTMS,
	PN_SYSCLKEN,
	PN_TDI,
	PN_TDO,
	PN_TESTMODE,
	PN_TRACECLK,
	PN_TRACEDT00,
	PN_TRACEDT01,
	PN_TRACEDT02,
	PN_TRACEDT03,
	PN_TRACEDT04,
	PN_TRACEDT05,
	PN_TRACEDT06,
	PN_TRACEDT07,
	PN_TRSTB,
	PN_TXDATA3G0,
	PN_UBCTSN,
	PN_UBRTSN,
	PN_UBRX,
	PN_UBTX,
	PN_TRACEDT08,
	PN_TRACEDT09,
	PN_TRACEDT10,
	PN_TRACEDT11,
	PN_TRACEDT12,
	PN_TRACEDT13,
	PN_TRACEDT14,
	PN_TRACEDT15,
	PN_MAX
};

/* define function name, order is not important */

enum PIN_FUNC {
	PF_RESERVED = 0,
	PF_GPIO00,
	PF_FIRST_GPIO = PF_GPIO00,
	PF_GPIO01,
	PF_GPIO02,
	PF_GPIO03,
	PF_GPIO04,
	PF_GPIO05,
	PF_GPIO06,
	PF_GPIO07,
	PF_GPIO08,
	PF_GPIO09,
	PF_GPIO10,
	PF_GPIO11,
	PF_GPIO12,
	PF_GPIO13,
	PF_GPIO14,
	PF_GPIO15,
	PF_GPIO16,
	PF_GPIO17,
	PF_GPIO18,
	PF_GPIO19,
	PF_GPIO20,
	PF_GPIO21,
	PF_GPIO22,
	PF_GPIO23,
	PF_GPIO24,
	PF_GPIO25,
	PF_GPIO26,
	PF_GPIO27,
	PF_GPIO28,
	PF_GPIO29,
	PF_GPIO30,
	PF_GPIO31,
	PF_GPIO32,
	PF_GPIO33,
	PF_GPIO34,
	PF_GPIO35,
	PF_GPIO36,
	PF_GPIO37,
	PF_GPIO38,
	PF_GPIO39,
	PF_GPIO40,
	PF_GPIO41,
	PF_GPIO42,
	PF_GPIO43,
	PF_GPIO44,
	PF_GPIO45,
	PF_GPIO46,
	PF_GPIO47,
	PF_GPIO48,
	PF_GPIO49,
	PF_GPIO50,
	PF_GPIO51,
	PF_GPIO52,
	PF_GPIO53,
	PF_GPIO54,
	PF_GPIO55,
	PF_GPIO56,
	PF_GPIO57,
	PF_GPIO58,
	PF_GPIO59,
	PF_GPIO60,
	PF_GPIO61,
	PF_GPIO62,
	PF_GPIO63,
	PF_GPIO64,
	PF_GPIO65,
	PF_GPIO66,
	PF_GPIO67,
	PF_GPIO68,
	PF_GPIO69,
	PF_GPIO70,
	PF_GPIO71,
	PF_GPIO72,
	PF_GPIO73,
	PF_GPIO74,
	PF_GPIO75,
	PF_GPIO76,
	PF_GPIO77,
	PF_GPIO78,
	PF_GPIO79,
	PF_GPIO80,
	PF_GPIO81,
	PF_GPIO82,
	PF_GPIO83,
	PF_GPIO84,
	PF_GPIO85,
	PF_GPIO86,
	PF_GPIO87,
	PF_GPIO88,
	PF_GPIO89,
	PF_GPIO90,
	PF_GPIO91,
	PF_GPIO92,
	PF_GPIO93,
	PF_GPIO94,
	PF_GPIO95,
	PF_GPIO96,
	PF_GPIO97,
	PF_GPIO98,
	PF_GPIO99,
	PF_GPIO100,
	PF_GPIO101,
	PF_GPIO102,
	PF_GPIO103,
	PF_GPIO104,
	PF_GPIO105,
	PF_GPIO106,
	PF_GPIO107,
	PF_GPIO108,
	PF_GPIO109,
	PF_GPIO110,
	PF_GPIO111,
	PF_GPIO112,
	PF_GPIO113,
	PF_GPIO114,
	PF_GPIO115,
	PF_GPIO116,
	PF_GPIO117,
	PF_GPIO118,
	PF_GPIO119,
	PF_GPIO120,
	PF_GPIO121,
	PF_GPIO122,
	PF_GPIO123,
	PF_GPIO124,
	PF_GPIO125,
	PF_GPIO126,
	PF_GPIO127,
	PF_LAST_GPIO = PF_GPIO127,
	PF_LCDCS0,
	PF_PC3,
	PF_BSC3_CLK,
	PF_LCDCD,
	PF_LCDSCL,
	PF_BSC3_SDA,
	PF_LCDD0,
	PF_LCDSDA,
	PF_BSC4_CLK,
	PF_BSC4_SDA,
	PF_LCDTE,
	PF_ANA_SYS_REQ1,
	PF_MMCX_GPO,
	PF_LCDD16,
	PF_AP_RSTN,
	PF_CLASSGPWR,
	PF_ANA_SYS_REQ2,
	PF_LCDD17,
	PF_CLK_MON,
	PF_AP_DAC_DATA_I,
	PF_UBRX,
	PF_PWM4,
	PF_DCLK4,
	PF_UBTX,
	PF_PWM5,
	PF_DCLKREQ4,
	PF_UBRTSN,
	PF_UB3RX,
	PF_UB3RTSN,
	PF_OSC1_OUT,
	PF_UBCTSN,
	PF_UB3CTSN,
	PF_OSC2_OUT,
	PF_PMBSCCLK,
	PF_PMBSCDAT,
	PF_BSC1CLK,
	PF_BSC1DAT,
	PF_SIMRSTN,
	PF_SIMDAT,
	PF_SIMCLK,
	PF_SIMDET,
	PF_MMC0CK,
	PF_SSP2CK,
	PF_MMC0CMD,
	PF_SSP2DO,
	PF_MMC0RSTN,
	PF_MMC0DAT7,
	PF_SYSCLKREQA,
	PF_MMC0DAT6,
	PF_SYSCLKREQB,
	PF_MMC0DAT5,
	PF_DCLK2,
	PF_MMC0DAT4,
	PF_DCLK3,
	PF_MMC0DAT3,
	PF_SSP2SYN,
	PF_MMC0DAT2,
	PF_MMC0DAT1,
	PF_MMC0DAT0,
	PF_SSP2DI,
	PF_MMC1CK,
	PF_PTI_CLK,
	PF_MMC1CMD,
	PF_MMC1RSTN,
	PF_PWM3,
	PF_MMC1DAT7,
	PF_ANA_SYS_REQ3,
	PF_SD1CK,
	PF_MMC1DAT6,
	PF_SLEEPCLKTST,
	PF_SD1CMD,
	PF_AP_IHF_DATA_I,
	PF_MMC1DAT5,
	PF_SD1DAT0,
	PF_MMC1DAT4,
	PF_SD1DAT3,
	PF_MMC1DAT3,
	PF_PTI_DAT3,
	PF_PWM2,
	PF_MMC1DAT2,
	PF_PTI_DAT2,
	PF_PWM1,
	PF_MMC1DAT1,
	PF_PTI_DAT1,
	PF_PWM0,
	PF_MMC1DAT0,
	PF_PTI_DAT0,
	PF_SDCK,
	PF_SSP1CK,
	PF_U1TXD,
	PF_SDCMD,
	PF_SSP1DO,
	PF_U1RXD,
	PF_SDDAT3,
	PF_SWCLKTCK,
	PF_PM_DEBUG3,
	PF_SDDAT2,
	PF_SWDIOTMS,
	PF_PM_DEBUG2,
	PF_SDDAT1,
	PF_SSP1SYN,
	PF_PM_DEBUG1,
	PF_SDDAT0,
	PF_SSP1DI,
	PF_PM_DEBUG0,
	PF_DMIC1DQ,
	PF_SIM2RST,
	PF_SIM2DAT,
	PF_DMIC1CLK,
	PF_SIM2CLK,
	PF_SIM2DET,
	PF_SSP0SYN,
	PF_AP_LRCK_I,
	PF_SSP0CK,
	PF_AP_SCLK_I,
	PF_SSP0DO,
	PF_AP_ADC_DATA_O,
	PF_SSP0DI,
	PF_AP_REF_2P4M_CLK,
	PF_SD1DAT1,
	PF_GPEN13,
	PF_SD1DAT2,
	PF_AFCPDM,
	PF_GPEN15,
	PF_GPEN12,
	PF_GPEN10,
	PF_RTCK,
	PF_GPEN11,
	PF_TRACECLK,
	PF_DSPTRACECLK,
	PF_TRACEDT15,
	PF_DSPTRACEDT15,
	PF_KEY_R0,
	PF_TRACEDT14,
	PF_DSPTRACEDT14,
	PF_KEY_R1,
	PF_TRACEDT13,
	PF_DSPTRACEDT13,
	PF_KEY_R2,
	PF_TRACEDT12,
	PF_DSPTRACEDT12,
	PF_KEY_R3,
	PF_TRACEDT11,
	PF_DSPTRACEDT11,
	PF_KEY_C0,
	PF_TRACEDT10,
	PF_DSPTRACEDT10,
	PF_KEY_C1,
	PF_TRACEDT09,
	PF_DSPTRACEDT09,
	PF_KEY_C2,
	PF_TRACEDT08,
	PF_DSPTRACEDT08,
	PF_KEY_C3,
	PF_TRACEDT07,
	PF_DSPTRACEDT07,
	PF_KEY_R4,
	PF_TRACEDT06,
	PF_DSPTRACEDT06,
	PF_KEY_R5,
	PF_TRACEDT05,
	PF_DSPTRACEDT05,
	PF_KEY_R6,
	PF_TRACEDT04,
	PF_DSPTRACEDT04,
	PF_KEY_R7,
	PF_TRACEDT03,
	PF_DSPTRACEDT03,
	PF_KEY_C4,
	PF_TRACEDT02,
	PF_DSPTRACEDT02,
	PF_KEY_C5,
	PF_TRACEDT01,
	PF_DSPTRACEDT01,
	PF_KEY_C6,
	PF_TRACEDT00,
	PF_DSPTRACEDT00,
	PF_KEY_C7,
	PF_DCLK1,
	PF_DCLKREQ1,
	PF_LCDD15,
	PF_BBRF_TESTPORT00,
	PF_LCDD14,
	PF_BBRF_TESTPORT01,
	PF_LCDD13,
	PF_BBRF_TESTPORT02,
	PF_LCDD12,
	PF_BBRF_TESTPORT03,
	PF_BBRF_TESTPORT04,
	PF_BBRF_TESTPORT05,
	PF_BBRF_TESTPORT06,
	PF_BBRF_TESTPORT07,
	PF_LCDD11,
	PF_BBRF_TESTPORT08,
	PF_LCDD10,
	PF_BBRF_TESTPORT09,
	PF_LCDD9,
	PF_BBRF_TESTPORT10,
	PF_LCDD8,
	PF_BBRF_TESTPORT11,
	PF_T_SHUTDOWN,
	PF_BBRF_TESTPORT12,
	PF_BBRF_TESTPORT13,
	PF_BBRF_TESTPORT14,
	PF_BBRF_TESTPORT15,
	PF_BSC2CLK,
	PF_BSC2DAT,
	PF_LCDCS1,
	PF_UB2TX,
	PF_GPEN09,
	PF_LCDWE,
	PF_UB2RX,
	PF_LCDRE,
	PF_UB2RTSN,
	PF_LCDD7,
	PF_UB2CTSN,
	PF_LCDD6,
	PF_SSP3CK,
	PF_LCDD5,
	PF_SSP3SYN,
	PF_LCDD4,
	PF_SSP3DI,
	PF_LCDD3,
	PF_SSP3DO,
	PF_LCDD2,
	PF_LCDD1,
	PF_UB3TX,
	PF_BATRM,
	PF_STAT1,
	PF_SIMLDO_EN,
	PF_STAT2,
	PF_SIM2LDO_EN,
	PF_DSI0TE,
	PF_GPEN00,
	PF_GPEN01,
	PF_GPEN02,
	PF_GPEN14,
	PF_GPEN04,
	PF_GPEN05,
	PF_GPEN06,
	PF_GPEN07,
	PF_GPEN08,
	PF_TESTMODE,
	PF_RESETN,
	PF_CLK32K,
	PF_PC1,
	PF_PC2,
	PF_TDO,
	PF_TDI,
	PF_TRSTB,
	PF_USBDP,
	PF_USBDN,
	PF_DMIC0CLK,
	PF_DMIC0DQ,
	PF_SRI_C,
	PF_SRI_E,
	PF_SRI_D,
	PF_GPEN03,
	PF_TXDATA3G0,
	PF_RTXDATA2G_TXDATA3G1,
	PF_RTXEN2G_TXDATA3G2,
	PF_RXDATA3G0,
	PF_RXDATA3G1,
	PF_RXDATA3G2,
	PF_CLK_CX8,
	PF_SYSCLKEN,
	PF_MAX
};

/* each Pin has up to 6 functions */
#define MAX_ALT_FUNC            6

#endif /* __CHIP_PINMUX_H__ */
