#ifndef __JAVA_PWR_MNGR_H__
#define __JAVA_PWR_MNGR_H__

#include <mach/rdb/brcm_rdb_pwrmgr.h>
#ifdef CONFIG_DEBUG_FS
#include <linux/stringify.h>
#include <mach/rdb/brcm_rdb_bmdm_pwrmgr.h>
#endif
#define PWRMGR_EVENT_NEGEDGE_CONDITION_ENABLE_MASK	\
			PWRMGR_LCDTE_EVENT_LCDTE_NEGEDGE_CONDITION_ENABLE_MASK
#define PWRMGR_EVENT_POSEDGE_CONDITION_ENABLE_MASK	\
			PWRMGR_LCDTE_EVENT_LCDTE_POSEDGE_CONDITION_ENABLE_MASK
#define PWRMGR_EVENT_CONDITION_ACTIVE_MASK		\
				PWRMGR_LCDTE_EVENT_LCDTE_CONDITION_ACTIVE_MASK

#define PWRMGR_HW_SEM_WA_PI_ID		PI_MGR_PI_ID_ARM_CORE
#define PWRMGR_HW_SEM_LOCK_WA_PI_OPP	PI_OPP_TURBO
#ifdef CONFIG_DEBUG_FS
#define PWRMGR_EVENT_ID_TO_STR(e) __event2str[e]

#ifdef CONFIG_KONA_PWRMGR_SWSEQ_FAKE_TRG_ERRATUM
#define PWRMGR_SW_SEQ_PC_PIN		PC3
#endif

#define PM_I2C_CMD_MAX	128

#define PWRMGR_I2C_CMD_BANK0_OFFSET				(0x4104)
#define PWRMGR_I2C_CMD_BANK1_OFFSET				(0x4280)

extern const char *__event2str[];
#endif

/*PM policy definitions */
#define PM_OFF		0
#define PM_RET		1
#define	PM_ECO		4
#define	PM_DFS		5
#define	PM_WKP		7


enum {
	LCDTE_EVENT = 0,
	SSP2SYN_EVENT,		/*1*/
	SSP2DI_EVENT,		/*2*/
	SSP2CK_EVENT,		/*3*/
	SSP1SYN_EVENT,		/*4*/
	SSP1DI_EVENT,		/*5*/
	SSP1CK_EVENT,		/*6*/
	SSP0SYN_EVENT,		/*7*/
	SSP0DI_EVENT,		/*8*/
	SSP0CK_EVENT,		/*9*/
	DIGCLKREQ_EVENT,	/*10 - 0xA*/
	ANA_SYS_REQ_EVENT,	/*11*/
	SYSCLKREQ_EVENT,	/*12*/
	UBRX_EVENT,		/*13 - 0xd*/
	UBCTSN_EVENT,		/*14*/
	UB2RX_EVENT,		/*15*/
	UB2CTSN_EVENT,		/*16 or 0x10*/
	SIMDET_EVENT,		/*17*/
	SIM2DET_EVENT,		/*18*/
	MMC0D3_EVENT,		/*19*/
	MMC0D1_EVENT,		/*20*/
	MMC1D3_EVENT,		/*21*/
	MMC1D1_EVENT,		/*22*/
	SDDAT3_EVENT,		/*23*/
	SDDAT1_EVENT,		/*24 or 0x18*/
	SLB1CLK_EVENT,		/*25*/
	SLB1DAT_EVENT,		/*26*/
	SWCLKTCK_EVENT,		/*27*/
	SWDIOTMS_EVENT,		/*28*/
	KEY_R0_EVENT,		/*29 or 0x1D*/
	KEY_R1_EVENT,		/*30*/
	KEY_R2_EVENT,		/*31*/
	KEY_R3_EVENT,		/*32*/
	KEY_R4_EVENT,		/*33*/
	KEY_R5_EVENT,		/*34*/
	KEY_R6_EVENT,		/*35*/
	KEY_R7_EVENT,		/*36*/
	DUMMY_EVENT1,	/*missing reg hence added dummy event - 37*/
	DUMMY_EVENT2,	/*missing reg hence added dummy event - 38*/
	MISC_WKP_EVENT,		/*39*/
	BATRM_EVENT,		/*40*/
	USBDP_EVENT,		/*41*/
	USBDN_EVENT,		/*42*/
	RXD_EVENT,			/*43*/
	GPIO29_A_EVENT,		/*44*/
	GPIO32_A_EVENT,		/*45*/
	GPIO33_A_EVENT,		/*46*/
	GPIO43_A_EVENT,		/*47*/
	GPIO44_A_EVENT,		/*48 or 0x30*/
	GPIO45_A_EVENT,		/*49*/
	GPIO46_A_EVENT,		/*50*/
	GPIO47_A_EVENT,		/*51*/
	GPIO48_A_EVENT,		/*52*/
	GPIO71_A_EVENT,		/*53*/
	GPIO72_A_EVENT,		/*54*/
	GPIO73_A_EVENT,		/*55*/
	GPIO74_A_EVENT,		/*56*/
	GPIO95_A_EVENT,		/*57*/
	GPIO96_A_EVENT,		/*58*/
	GPIO99_A_EVENT,		/*59*/
	GPIO100_A_EVENT,	/*60*/
	GPIO111_A_EVENT,	/*61*/
	GPIO18_A_EVENT,		/*62*/
	GPIO19_A_EVENT,		/*63*/
	GPIO20_A_EVENT,		/*64 or 0x40*/
	GPIO89_A_EVENT,		/*65*/
	GPIO90_A_EVENT,		/*66*/
	GPIO91_A_EVENT,		/*67*/
	GPIO92_A_EVENT,		/*68*/
	GPIO93_A_EVENT,		/*69*/
	GPIO18_B_EVENT,		/*70*/
	GPIO19_B_EVENT,		/*71*/
	GPIO20_B_EVENT,		/*72*/
	GPIO89_B_EVENT,		/*73*/
	GPIO90_B_EVENT,		/*74*/
	GPIO91_B_EVENT,		/*75*/
	GPIO92_B_EVENT,		/*76*/
	GPIO93_B_EVENT,		/*77*/
	GPIO29_B_EVENT,		/*78*/
	GPIO32_B_EVENT,		/*79*/
	GPIO33_B_EVENT,		/*80*/
	GPIO43_B_EVENT,		/*81*/
	GPIO44_B_EVENT,		/*82*/
	GPIO45_B_EVENT,		/*83*/
	GPIO46_B_EVENT,		/*84*/
	GPIO47_B_EVENT,		/*85*/
	GPIO48_B_EVENT,		/*86*/
	GPIO71_B_EVENT,		/*87*/
	GPIO72_B_EVENT,		/*88*/
	GPIO73_B_EVENT,		/*89*/
	GPIO74_B_EVENT,	/*90 */
	GPIO95_B_EVENT,		/*91*/
	GPIO96_B_EVENT,		/*92*/
	GPIO99_B_EVENT,		/*93*/
	GPIO100_B_EVENT,	/*94*/
	GPIO111_B_EVENT,	/*95*/
	COMMON_TIMER_0_EVENT,	/*96*/
	COMMON_TIMER_1_EVENT,	/*97*/
	COMMON_TIMER_2_EVENT,	/*98*/
	COMMON_TIMER_3_EVENT,	/*99*/
	COMMON_TIMER_4_EVENT,	/*100 - 0x64*/
	COMMON_INT_TO_AC_EVENT,	/*101*/
	TZCFG_INT_TO_AC_EVENT,	/*102*/
	DMA_REQUEST_EVENT,	/*103*/
	MODEM1_EVENT,		/*104*/
	MODEM2_EVENT,		/*105*/
	SD1DAT1DAT3_EVENT,	/*106*/
	BRIDGE_TO_AC_EVENT,	/*107*/
	BRIDGE_TO_MODEM_EVENT,	/*108*/
	VREQ_NONZERO_PI_MODEM_EVENT,/*109*/
	DUMMY_EVENT3,	/*missing reg hence added dummy event - 110*/
	USBOTG_EVENT,		/*111*/
	GPIO_EXP_IRQ_EVENT,	/*112*/
	DBR_IRQ_EVENT,		/*113*/
	ACI_EVENT,		/*114*/
	PHY_RESUME_EVENT,	/*115*/
	MODEMBUS_ACTIVE_EVENT,	/*116*/
	SOFTWARE_0_EVENT,	/*117*/
	SOFTWARE_1_EVENT,	/*118*/
	SOFTWARE_2_EVENT,	/*119*/
	PWR_MGR_NUM_EVENTS	/*num events - 120*/
};

int mach_init_sequencer(void);

#endif /*__JAVA_PWR_MNGR_H__*/
