/************************************************************************************************/
/*                                                                                              */
/*  Copyright 2010  Broadcom Corporation                                                        */
/*                                                                                              */
/*     Unless you and Broadcom execute a separate written software license agreement governing  */
/*     use of this software, this software is licensed to you under the terms of the GNU        */
/*     General Public License version 2 (the GPL), available at                                 */
/*                                                                                              */
/*          http://www.broadcom.com/licenses/GPLv2.php                                          */
/*                                                                                              */
/*     with the following added to such license:                                                */
/*                                                                                              */
/*     As a special exception, the copyright holders of this software give you permission to    */
/*     link this software with independent modules, and to copy and distribute the resulting    */
/*     executable under terms of your choice, provided that you also meet, for each linked      */
/*     independent module, the terms and conditions of the license of that module.              */
/*     An independent module is a module which is not derived from this software.  The special  */
/*     exception does not apply to any modifications of the software.                           */
/*                                                                                              */
/*     Notwithstanding the above, under no circumstances may you combine this software in any   */
/*     way with any other Broadcom software provided under a license other than the GPL,        */
/*     without Broadcom's express prior written consent.                                        */
/*                                                                                              */
/************************************************************************************************/

#ifndef __DMA_PL330_PDATA_H
#define __DMA_PL330_PDATA_H

/*
 * The platforms just need to provide this info to the KONA DMA API
 */
struct kona_pl330_data {
	/* Non Secure DMAC virtual base address */
	void __iomem *dmac_ns_base;
	/* Secure DMAC virtual base address */
	void __iomem *dmac_s_base;
	/* # of PL330 dmac channels 'configurable' */
	unsigned int num_pl330_chans;
	/* DMAC irq number, connected to GIC */
	int irq_base;
	/* # of PL330 Interrupts/events 'configurable' */
	unsigned int irq_line_count;
	//int dmac_abort_irq;
};

#endif /* __DMA_PL330_PDATA_H */
